---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "ws-station.fullname" . }}-postgres
  labels:
    app: postgres
    {{- include "ws-station.labels" . | nindent 4 }}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: postgres
      {{- include "ws-station.labels" . | nindent 6 }}
  template:
    metadata:
      labels:
        app: postgres
        {{- include "ws-station.labels" . | nindent 8 }}
        {{- with .Values.podLabels }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
    spec:
      terminationGracePeriodSeconds: 5
      containers:
        - name: postgres
          image: postgres:16
          ports:
            - name: postgres
              containerPort: 5432
              protocol: TCP
          env:
            - name: POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ include "ws-station.fullname" . }}
                  key: PGPASSWORD
            - name: POSTGRES_USER
              valueFrom:
                configMapKeyRef:
                  name: {{ include "ws-station.fullname" . }}
                  key: PGUSER
            - name: POSTGRES_DB
              valueFrom:
                configMapKeyRef:
                  name: {{ include "ws-station.fullname" . }}
                  key: PGDATABASE
            - name: SRC_PGHOST
              value: {{ .Values.postgres.sourcedb.PGHOST }}
            - name: SRC_PGDATABASE
              value: {{ .Values.postgres.sourcedb.PGDATABASE }}
          resources:
            {{- toYaml .Values.postgres.resources | nindent 12 }}
          volumeMounts:
            - name: resifinv-init-scripts
              mountPath: /docker-entrypoint-initdb.d
          readinessProbe:
            exec:
              command:
                - /bin/bash
                - "-c"
                - "[[ $(psql -U {{ .Values.config.PGUSER }} -d {{ .Values.config.PGDATABASE }} -qtAc 'select count(*) from response') -gt 1 ]]"
            initialDelaySeconds: 10
            timeoutSeconds: 5
          livenessProbe:
            exec:
              command:
                - psql
                - "-U"
                - {{ .Values.config.PGUSER }}
                - "-d"
                - {{ .Values.config.PGDATABASE }}
                - "-qtAc"
                - select 1
            timeoutSeconds: 5
      volumes:
        - name: resifinv-init-scripts
          configMap:
            name: {{ include "ws-station.fullname" . }}-postgres
